//  This class represents a Bucket
public class Bucket {            
// The attributes of the class
private double capacity;
private double currentAmount;
/* A constructor for the class. receives one parameter for capacity.
Builds a new empty Bucket according to this parameter */
public Bucket (double capacity)
{
	     this.capacity = capacity;
	     this.currentAmount = 0;
}

// Methods:
/* returns the capacity of the bucket */
public double getCapacity()
{	
     return this.capacity;
}	
/* returns the current amount in the bucket */
public double getCurrentAmount()
{	   
     return  this.currentAmount;
} 
/* receives amount and add it to the amount it the bucket */
public void addAmount (double amountToAdd)
{
     // if the capacity is too small 
     if (this.capacity < this.currentAmount + amountToAdd)
    {	    
         this.currentAmount = this.capacity;
    }
    else 
         this.currentAmount = this.currentAmount+ amountToAdd;
}
/* receives amount and remove it from the bucket */
public void removeAmount (double amountToRemove)
{
     if (this.currentAmount < amountToRemove)
          this.currentAmount = 0;
    else 
        this.currentAmount = this.currentAmount- amountToRemove;
}
/* empties the bucket completely */
public void emptyAll()
{
     this.currentAmount = 0;
}
/* checks if the bucket is empty */
public boolean isEmpty()
{
     return this.currentAmount == 0;
}
/* builds and returns a String from the bucket's attributes and their value */
public String toString()
{
     return "(my capacity=" + this.capacity +"  my current amount=" + this.currentAmount+")";
}
}// end of class
